# led_berries.py
# $Rev$
# Copyright (c) 2015 Able Systems Limited. All rights reserved.
'''This simple code example is provided as-is, and is for demonstration
purposes only. Able Systems takes no responsibility for any system
implementations based on this code.

This script drives the GPIO lines and hence LEDs with a fixed pattern.

Copyright (c) 2015, Able Systems Ltd. All rights reserved.
'''

import time
import RPi.GPIO as GPIO


GPIO2 = 2
GPIO3 = 3
GPIO4 = 4

#Pattern strings below are effectively groups of 6 LED operation modes
pattern_strings = [ '111', # Constant ON for 6 time intervals
                    '111',
                    '111',
                    '111',
                    '111',
                    '111',
                    '000', # Grow then shrink
                    '001',
                    '011',
                    '111',
                    '011',
                    '001',      
                    '010',  # Walk
                    '100',                                                                  
                    '010',      
                    '001',                              
                    '010',                  
                    '100',                                      
                    '111',  # Flash                                 
                    '000',                                      
                    '111',                                  
                    '000',                                      
                    '111',
                    '000'                                       
                     ]

SLEEP_TIME = 0.25 # Change this value for faster or slower stepping through the sequence

GPIO.setmode(GPIO.BCM)

# Start with all lines as outputs
GPIO.setup(GPIO2,GPIO.OUT)
GPIO.setup(GPIO3,GPIO.OUT)
GPIO.setup(GPIO4,GPIO.OUT)


# Loop forever. Press CTRL-Z to exit the script

try:
    while True:
        for pattern in pattern_strings:
            print("Displaying: {}".format(pattern))
            if pattern[0] == '1':
                GPIO.output(GPIO2, 1)
            else:
                GPIO.output(GPIO2, 0)
            if pattern[1] == '1':
                GPIO.output(GPIO3, 1)
            else:
                GPIO.output(GPIO3, 0)
            if pattern[2] == '1':
                GPIO.output(GPIO4, 1)
            else:
                GPIO.output(GPIO4, 0)
            time.sleep(SLEEP_TIME)
except:
    GPIO.cleanup()
